<!-- 媒体添加或者删除  medium_edit-->
<template>
  <div class=" mb50" v-loading="!richShow">
    <el-form class="form" :model="form" :rules="rules" ref="ruleForm" label-width="110px">
      <!-- 产品名称 -->
      <el-form-item label="标题" prop="name">
        <el-input v-model="form.name"></el-input>
      </el-form-item>



      <div class="flex">

        <el-form-item label="状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择媒体类型">
            <el-option label="正常" value="0"></el-option>
            <el-option label="屏蔽" value="1"></el-option>
          </el-select>
        </el-form-item>

      </div>

      <div class="flex">
        <el-form-item label="上传标题图" prop="img">
          <el-upload class="avatar-uploader" :action="m_action" :show-file-list="true" name="images" :with-credentials="true" :on-success="handleAvatarSuccess">

            <button v-if="form.button" class=" btn btn-primary w100 ">上传图片</button>
            <span v-else> </span>
            <img  v-if="form.preview" :src="form.img" class="avatar">
            <span v-else> </span>

          </el-upload>
          <!-- <p class="m_red">( 请上传图片规格 宽*高 698px* 154px )</p> -->
        </el-form-item>
      </div>





      <el-form-item label="内容">
        <rich-txt v-if="richShow" width="100%" ref="richTxt" :content="form.content" />
      </el-form-item>

    </el-form>

    <div class="mt50 pt50 tr">
      <el-button type="primary" class="w100" :loading="m_loading" @click="publishContent">提交</el-button>

    </div>

  </div>

</template>

<script>
import * as utils from '@/utils/index'
import E from 'wangeditor'
import richTxt from '@/components/richTxt'
export default {
  name: 'medium_edit',
  components: { richTxt },
  props: ['aId'],
  data() {
    return {

      // aId: this.$route.query.id,

      richShow: true,

      options: [],
      classes: [],
      form: {
        bannerImg: '',
        name: '', //	标题
        author: '', //作者
        img: [''],//标题图片(支持多图)
        type: '1', //媒体类型 1:文章 2:图集(未开放) 3:视频(未开放)
        description: '0',// 分类概述
        url: '0',// 分类跳转链接
        pid: '0',// 一级分类
        cid: '0',// 二级分类
        sort: '',// 排序 (从大到小排序)
        status: '0',// 状态 0:正常   1:屏蔽
        up: '0',// 点赞数
        down: '0',// 挖坑数
        read_num: '0',// 阅读数
        content: '',
        button: true , // for button
        preview : false




      },
      rules: {
        name: [
          { required: true, message: '请输入标题', trigger: 'blur' },
        ],
        description: [
          { required: true, message: '请输入', trigger: 'blur' },
        ],





      }
    }
  },

  computed: {

  },
  mounted() {



    if (this.aId) {
      this.m_loading = true
      this.richShow = false

      this.m_api.medium_show({ id: this.aId }).then(res => {
        console.log(res)
        this.form = utils.coverObj(this.form, res.data)
        console.log(this.form.img)
        this.form.img = res.data.img || []
        this.classes = [this.form.pid, this.form.cid].filter(i => i != 0 && i)
        this.m_loading = false
        this.richShow = true
        this.form.button = true
        this.form.preview = true

 


      }).catch(res => {
        this.m_loading = false
        this.richShow = true
      })
    }


  },

  methods: {
    handleAvatarSuccess(res, file) {
      this.form.img = [res.data]
      this.form.button = true
      this.form.preview = true
    },
    //提交文章
    publishContent: function () {
      this.form.content = this.$refs.richTxt.getContent()
      this.$refs['ruleForm'].validate((valid) => {
        if (valid) {
          if (this.form.content.length < 0) {
            this.m_error('请多输入点东西')

          } else {
            this.form.pid = this.classes[0] || ''
            this.form.cid = this.classes[1] || ''
            if (this.aId) {
              this.edit_user_article()
            } else {
              this.add_article()
            }


          }

        } else {
          console.log('error submit!!');
          return false;
        }
      })

    },







    //编辑文章
    edit_user_article() {
      this.m_loading = true
      this.m_api.medium_update(Object.assign(this.form, { id: this.aId })).then(res => {
        this.m_loading = false

        this.$emit('success')
      }).catch(res => {

      })

    },

    //添加文章
    add_article() {
      this.m_loading = true
      this.m_api.medium_add(this.form).then(res => {

        this.$emit('success')
      }).catch(res => {
        this.m_loading = false

      })
    },


    handleAvatarSuccessImgs(res, file) {
      this.form.img.push(res.data)
    },
    delIMgs(imgarr, index) {
      this.form.img.splice(index, 1)
    },





  },



}

</script>
<style lang='scss' scoped>
.form {
  position: relative;
  z-index: 300;
}

.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
  border: 1px solid #eee;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
}

.imgss {
  position: relative;
  .imgss_color {
    position: absolute;
    top: 5px;
    right: 5px;
    font-size: 18px;
    color: #999;
  }
  .imgss_color:hover {
    color: #333;

  }
}
</style>
